/* EPS Conduits (C) 2014-2017 Stephane Charette <stephanecharette@gmail.com>
 * $Id: tun_tap.hpp 2167 2017-03-01 12:10:04Z stephane $
 * See license.txt.
 */

#pragma once

#include <string>
#include "common.hpp"


namespace EPS
{
	/// Verify that the network doesn't conflict with any existing network setting.
	bool validate_network_against_existing_routes(const uint32_t &eps_network_in_host_order, const uint32_t &eps_netmask_in_host_order);

	/// Raise the expected TUN/TAP interface.
	void raise_tun_tap_interface(const uint32_t ip_address_in_network_order, std::string &device_name, FILE_HANDLE_DESCRIPTOR &device_fd);

	/// Setup a route for the TUN/TAP interface.
	void set_tun_tap_routes(const uint32_t &network_in_network_order, const uint32_t &netmask_in_network_order, const std::string  &device_name);

	/// Cleanly shut down the TUN/TAP interface.
	void close_tun_tap_interface(std::string &device_name, FILE_HANDLE_DESCRIPTOR &device_fd);
}
