/* EPS Conduits (C) 2014-2017 Stephane Charette <stephanecharette@gmail.com>
 * $Id: demangle.cpp 2167 2017-03-01 12:10:04Z stephane $
 * See license.txt.
 */

#include "common.hpp"
#ifndef EPS_WINDOWS
	#include <cxxabi.h>
#endif


std::string EPS::cpp_demangle(const std::string &str)
{
	std::string result = str;

	#ifndef EPS_WINDOWS
		int status = -1;
		char *demangledName = abi::__cxa_demangle( str.c_str(), NULL, NULL, &status );
		if ( status == 0 )
		{
			// we successfully demangled the given name, so remember the result
			result = demangledName;
		}
		free( demangledName );
	#endif

	return result;
}
